
Ruby - Bug #12139

return OpenSSL::Random.random_bytes(n) call takes to long. OpenSSL:: bug on windows.

03/03/2016 05:45 AM - Justin (Justin Ward)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: 2.2.4 Backport: 2.1: WONTFIX, 2.2: DONE, 2.3: DONE

Description

I have been a windows dev for a while now. I have never solved this rails startup issue. Running one Rspec test takes rails 22

seconds to load on my PC. When I (temporarily) comment out the line in securerandom.rb and replace it with a hardcoded return the

startup time is reduced to 10 seconds.

#return OpenSSL::Random.random_bytes(n)

return "\xD3\x04F\f0\xD6{G\xB9\x81"

 I can duplicate this on a windows 7 and windows 10 PC.

I have the lastest version of OpenSSL (1.02) installed.

Tickets like this have been reported before, but they get closed without being solved for unknown reasons. Please share the joy of

Ruby with us PC users :).

See this more more info: 

http://stackoverflow.com/questions/29984838/openssl-causing-very-slow-rails-boot-time-on-windows/35749120#35749120

Associated revisions

Revision 6545327e24c0efc7bb0cb32cd2043d79ea365790 - 03/17/2016 06:01 AM - naruse (Yui NARUSE)

lib/securerandom.rb (gen_random): to avoid blocking on Windows.

On Windows OpenSSL RAND_bytes (underlying implementation is

RAND_poll in crypto/rand/rand_win.c) may be blocked at

NetStatisticsGet.

https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

Instead of this, use Random.raw_seed directory (whose implementation

CryptGenRandom is one of the source of

entropy of RAND_poll on Windows).

https://wiki.openssl.org/index.php/Random_Numbers

Note: CryptGenRandom function is PRNG and doesn't check its entropy,

so it won't block. [Bug #12139]

https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

https://tools.ietf.org/html/rfc4086#section-7.1.3

https://eprint.iacr.org/2007/419.pdf

http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@54144 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6545327e - 03/17/2016 06:01 AM - naruse (Yui NARUSE)

lib/securerandom.rb (gen_random): to avoid blocking on Windows.

On Windows OpenSSL RAND_bytes (underlying implementation is

RAND_poll in crypto/rand/rand_win.c) may be blocked at

NetStatisticsGet.

https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

Instead of this, use Random.raw_seed directory (whose implementation

CryptGenRandom is one of the source of

entropy of RAND_poll on Windows).

https://wiki.openssl.org/index.php/Random_Numbers

Note: CryptGenRandom function is PRNG and doesn't check its entropy,

so it won't block. [Bug #12139]

https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

https://tools.ietf.org/html/rfc4086#section-7.1.3

https://eprint.iacr.org/2007/419.pdf

http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@54144 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision cb66eaab150fe8687c3b7b5bdd082c9016223b87 - 04/22/2016 09:17 AM - U.Nakamura 

merge revision(s) 54144: [Backport #12139]

    * lib/securerandom.rb (gen_random): to avoid blocking on Windows.

      On Windows OpenSSL RAND_bytes (underlying implementation is

      RAND_poll in crypto/rand/rand_win.c) may be blocked at

      NetStatisticsGet.

      https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

      Instead of this, use Random.raw_seed directory (whose implementation

      CryptGenRandom is one of the source of

      entropy of RAND_poll on Windows).

      https://wiki.openssl.org/index.php/Random_Numbers

      Note: CryptGenRandom function is PRNG and doesn't check its entropy,

      so it won't block. [Bug #12139]

      https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

      https://tools.ietf.org/html/rfc4086#section-7.1.3

      https://eprint.iacr.org/2007/419.pdf

      http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54693 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision cb66eaab - 04/22/2016 09:17 AM - U.Nakamura 

merge revision(s) 54144: [Backport #12139]

    * lib/securerandom.rb (gen_random): to avoid blocking on Windows.

      On Windows OpenSSL RAND_bytes (underlying implementation is

      RAND_poll in crypto/rand/rand_win.c) may be blocked at

      NetStatisticsGet.

      https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

      Instead of this, use Random.raw_seed directory (whose implementation

      CryptGenRandom is one of the source of

      entropy of RAND_poll on Windows).

      https://wiki.openssl.org/index.php/Random_Numbers

      Note: CryptGenRandom function is PRNG and doesn't check its entropy,

      so it won't block. [Bug #12139]

      https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

      https://tools.ietf.org/html/rfc4086#section-7.1.3

      https://eprint.iacr.org/2007/419.pdf

      http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@54693 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a8acc95f4c3b3b6ead0586139e4205326e0bc029 - 04/22/2016 03:30 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 54144,54699: [Backport #12139]

    * lib/securerandom.rb (gen_random): to avoid blocking on Windows.

      On Windows OpenSSL RAND_bytes (underlying implementation is

      RAND_poll in crypto/rand/rand_win.c) may be blocked at

      NetStatisticsGet.

      https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

      Instead of this, use Random.raw_seed directory (whose implementation

      CryptGenRandom is one of the source of

      entropy of RAND_poll on Windows).

      https://wiki.openssl.org/index.php/Random_Numbers

      Note: CryptGenRandom function is PRNG and doesn't check its entropy,

      so it won't block. [Bug #12139]

      https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

      https://tools.ietf.org/html/rfc4086#section-7.1.3

      https://eprint.iacr.org/2007/419.pdf

      http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

      Instead of this, use Random.raw_seed directly (whose implementation

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54713 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a8acc95f - 04/22/2016 03:30 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 54144,54699: [Backport #12139]

    * lib/securerandom.rb (gen_random): to avoid blocking on Windows.

      On Windows OpenSSL RAND_bytes (underlying implementation is
      RAND_poll in crypto/rand/rand_win.c) may be blocked at

      NetStatisticsGet.

      https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

      Instead of this, use Random.raw_seed directory (whose implementation

      CryptGenRandom is one of the source of

      entropy of RAND_poll on Windows).

      https://wiki.openssl.org/index.php/Random_Numbers

      Note: CryptGenRandom function is PRNG and doesn't check its entropy,

      so it won't block. [Bug #12139]

      https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

      https://tools.ietf.org/html/rfc4086#section-7.1.3

      https://eprint.iacr.org/2007/419.pdf

      http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

      Instead of this, use Random.raw_seed directly (whose implementation

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54713 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/03/2016 08:26 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Feedback

Maybe the entropy pool exhausted?

Does moving mouse or typing keyboard wake up OpenSSL?

#2 - 03/03/2016 08:27 AM - nobu (Nobuyoshi Nakada)

- Description updated

#3 - 03/03/2016 08:27 AM - naruse (Yui NARUSE)

Your issue sounds related with https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

But Bug 2100 the heap walk issue is closed.

Anyway maybe SecureRandom, RSpec actually calls, should use CryptGenRandom instead of openssl.

#4 - 03/03/2016 10:06 PM - Justin (Justin Ward)

Nobuyoshi Nakada wrote:

Maybe the entropy pool exhausted?

Does moving mouse or typing keyboard wake up OpenSSL?

 In the 22 seconds it takes rails to load i am usually writing code, so OpenSSL does not get woken up by keyboard or mouse activity.

#5 - 03/03/2016 10:11 PM - Justin (Justin Ward)

Yui NARUSE wrote:

Your issue sounds related with https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

But Bug 2100 the heap walk issue is closed.

Anyway maybe SecureRandom, RSpec actually calls, should use CryptGenRandom instead of openssl.

 CryptGenRandom would be an excellent solution in my opinion :)

#6 - 03/03/2016 10:42 PM - usa (Usaku NAKAMURA)

Random.raw_seed is an alternative to OpenSSL::Random.random_seed.

This calls CryptGenRandom internally.

BTW, I could not reproduce the problem on my environment (x64-mswin64, Win7, OpenSSL 1.0.2f).

Calling OpenSSL::Random.random_bytes 10,000,000 times takes about 11 seconds, but I think it's not so slow.

Calling Random.raw_seed is a little faster, but only 6.7%.

D:\ruby> ruby -ropenssl -e"t = Time.now; 10_000_000.times{}; p Time.now - t"

0.541031

D:\ruby> ruby -ropenssl -e"t = Time.now; 10_000_000.times{OpenSSL::Random.random_bytes(16)}; p Time.now - t"

11.243643

D:\ruby> ruby -e"t = Time.now; 10_000_000.times{Random.raw_seed(16)}; p Time.now - t"
10.533603

#7 - 03/03/2016 11:27 PM - usa (Usaku NAKAMURA)

Sorry, I've forgotten to note that Random.raw_seed is Ruby 2.3 feature.

#8 - 03/17/2016 06:01 AM - naruse (Yui NARUSE)

- Status changed from Feedback to Closed

Applied in changeset r54144.

lib/securerandom.rb (gen_random): to avoid blocking on Windows.

On Windows OpenSSL RAND_bytes (underlying implementation is

RAND_poll in crypto/rand/rand_win.c) may be blocked at

NetStatisticsGet.

https://wiki.openssl.org/index.php/Random_Numbers#Windows_Issues

Instead of this, use Random.raw_seed directory (whose implementation

CryptGenRandom is one of the source of

entropy of RAND_poll on Windows).

https://wiki.openssl.org/index.php/Random_Numbers

Note: CryptGenRandom function is PRNG and doesn't check its entropy,

so it won't block. [Bug #12139]

https://msdn.microsoft.com/ja-jp/library/windows/desktop/aa379942.aspx

https://tools.ietf.org/html/rfc4086#section-7.1.3

https://eprint.iacr.org/2007/419.pdf

http://www.cs.huji.ac.il/~dolev/pubs/thesis/msc-thesis-leo.pdf

#9 - 04/22/2016 07:54 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: WONTFIX, 2.2: REQUIRED, 2.3: REQUIRED

#10 - 04/22/2016 09:18 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: WONTFIX, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: WONTFIX, 2.2: DONE, 2.3: REQUIRED

ruby_2_2 r54693 merged revision(s) 54144.

#11 - 04/22/2016 03:30 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: WONTFIX, 2.2: DONE, 2.3: REQUIRED to 2.1: WONTFIX, 2.2: DONE, 2.3: DONE

ruby_2_3 r54713 merged revision(s) 54144,54699.
